(* 
   Ce module fournit des oprations efficaces sur un ensemble partitionn en
   un nombre fixe de partitions, mais dont les lments peuvent tre ajouts
   ou dplacs  d'une partition  une autre. L'ajout, le dplacement ou la
   consultation d'un lment d'une partition sont en temps amorti constant. 
*)

type 'a t 
type 'a elem
val make : int -> 'a t array
      (* make n crer un vecteur de partitions *)
val clear : 'a t array -> unit
       (* clear s efface la partition s e *)
    
val put : 'a t -> 'a -> 'a elem
      (* create s e crer un lment e dans la partition s *)
val info : 'a elem -> 'a
       (*  info e  retourne les informations sur l'lment e *)
val eq : 'a elem -> 'a elem -> bool
    
val belong : 'a elem -> 'a t -> bool
val move : 'a elem -> 'a t -> unit
val pick : 'a t -> 'a elem option
    ;;

(* oprations en temps linaire *)
val list : 'a t -> 'a elem list 
(* "pick_lowest cost" retourne un lment minimal pour la fonction "cost" *)
val pick_lowest : ('a elem -> 'b) -> 'a t -> 'a elem option

(* opration en temps O(n log n) *)
val sort : ('a elem -> 'a elem -> bool) -> 'a t -> unit
